﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HeuristicLab.Analysis.FitnessLandscape {
  public static class DictionaryExtensions {
    public static TValue GetValueOrDefault<TKey, TValue>(this IDictionary<TKey, TValue> d, TKey key, Func<TValue> provider) {
      var value = provider();
      d.TryGetValue(key, out value);
      return value;
    }
    public static TValue GetValueOrDefault<TKey, TValue>(this IDictionary<TKey, TValue> d, TKey key, TValue def) {
      var value = def;
      d.TryGetValue(key, out value);
      return value;
    }
    public static TValue GetValueOrDefault<TKey, TValue>(this IDictionary<TKey, TValue> d, TKey key) {
      var value = default(TValue);
      d.TryGetValue(key, out value);
      return value;
    }
  }
}
